﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.Text.RegularExpressions;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization;
using System.IO;
using System.Drawing.Printing;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public string data;
        public Socket Sock;
        public TcpClient Client;
        public Thread Receive;
        public string htmlTextElement;
        public string SelectPreperities;
        public Dictionary<string, string> searchElements;
        public Dictionary<string, string> SE;
        public Dictionary<string, bool> ItemChecked;
        public string vseVibraniiSvoistva;
        private Font printFont;

        private void button1_Click(object sender, EventArgs e)
        {            
            Client = new TcpClient();
            string Ip = ip.Text;
            string Port = port.Text;
            logs.Text = (DateTime.Now + ":> Соединение...");
            try
            {
                Client.Connect(Ip, Convert.ToInt32(Port));
            }
            catch
            {
                logs.Text = (logs.Text + Environment.NewLine + DateTime.Now + ":> Нет возможности подключиться к серверу!");
                return;
            }
            logs.Text = (logs.Text + Environment.NewLine + DateTime.Now + ":> Соединение установленно");
            Receive = new Thread(new ThreadStart(receiveData));
            Sock = Client.Client;
            Receive.Start();
        }

        private void SendDataToServer(string data)
        {
            Sock.Send(Encoding.UTF8.GetBytes(data));
        }

        private void button2_Click(object sender, EventArgs e)
        {
            data = request.Text;
            try
            {
                SendDataToServer(data);
            }
            catch (Exception ex) { }
            logs.Text = (logs.Text + Environment.NewLine + DateTime.Now + ":> " + data);
        }

        delegate void WriteToLogDelegate(string message);
        public void WriteToLog(string message)
        {
            if (listProperties.InvokeRequired)
            {
                var writeToLog = new WriteToLogDelegate(WriteToLog);
                listProperties.Invoke(writeToLog, message);
            }
            else
            {
                listProperties.Items.Add(message, false);
            }
        }

        delegate void DeliteToLogDelegate(int start, int count);
        public void DeliteToProperties(int start, int count)
        {
            if (properties.InvokeRequired)
            {
                var deliteToProperties = new DeliteToLogDelegate(DeliteToProperties);
                properties.Invoke(deliteToProperties,start,count);
            }
            else
            {
                properties.Select(start, count);
                properties.SelectedText = String.Empty;
            }
        }

        public void WriteToProperties(string message)
        {
            if (properties.InvokeRequired)
            {
                var writeToProperties = new WriteToLogDelegate(WriteToLog);
                properties.Invoke(writeToProperties, message);
            }
            else
            {
                properties.Text = Environment.NewLine + message;
            }
        }

        delegate void ClearListElementsDelegate();
        public void ClearListElements()
        {
            if (listElements.InvokeRequired)
            {
                var сlearListElements = new ClearListElementsDelegate(ClearListElements);
                listElements.Invoke(сlearListElements);
            }
            else
            {
                listElements.Items.Clear();
            }
        }

        delegate void ClearListPropertiesDelegate();
        public void ClearListProperties()
        {
            if (listElements.InvokeRequired)
            {
                var сlearListProperties = new ClearListPropertiesDelegate(ClearListProperties);
                listProperties.Invoke(сlearListProperties);
            }
            else
            {
                listProperties.Items.Clear();
            }
        }

        public void WriteTolist(string message)
        {
            if (listElements.InvokeRequired)
            {
                var writeTolist = new WriteToLogDelegate(WriteTolist);
                listElements.Invoke(writeTolist, message);
            }
            else
            {
                listElements.Items.Add(message);
            }
        }

        private void receiveData()
        {
            byte[] remdata = new byte[204800];           
            Sock = Client.Client;
            while (true)
            {
                int i = 0;
                try
                {
                    i = Sock.Receive(remdata);
                }
                catch
                {
                    Sock.Close();
                    return;
                }
                try
                {
                    if (i > 0)
                    {
                        htmlTextElement = Encoding.UTF8.GetString(remdata);
                        ClearListProperties();
                        if (htmlTextElement.Contains("<HTML>"))
                        {
                            for (int k = i; k > 0; k--)
                            {
                                if (remdata[k] != 0)
                                {
                                    remdata[k] = 0;
                                }
                            }
                            htmlTextElement = htmlTextElement.Replace("</sub>", "");
                            htmlTextElement = htmlTextElement.Replace("<sub>", "");
                            htmlTextElement = htmlTextElement.Replace("</sup>", "");
                            htmlTextElement = htmlTextElement.Replace("<sup>", "");
                            htmlToListBox(htmlTextElement);
                        }
                        else
                        {
                            ClearListElements();
                            getData(remdata);
                        }
                    }
                }
                catch
                {
                    Sock.Close();
                    return;
                }
            }
        }

        public void getData(byte[] htmlTextElement)
        {
            byte[] spisok = new byte[204800];            
            spisok = htmlTextElement;
            BinaryFormatter bFormat = new BinaryFormatter();
            MemoryStream mStream = new MemoryStream(spisok);
            searchElements = new Dictionary<string, string>();           
            try
            {
                searchElements = (Dictionary<string, string>)bFormat.Deserialize(mStream);
                foreach (KeyValuePair<string, string> kvp in searchElements)
                {
                    WriteTolist(kvp.Key);
                }
            }
            catch
            {
            }
        }

        public void htmlToListBox(string Page_Source_Code)
        {
            vseVibraniiSvoistva="";
            SE = new Dictionary<string, string>();
            ItemChecked = new Dictionary<string, bool>();
            Regex Reg = new Regex(@"(?<=\<h3\>)(.*?)(?=:)");
            try
            {
                MatchCollection matches = Reg.Matches(@Page_Source_Code);
                foreach (Match match in matches)
                {
                    string Data = clearText(match.ToString());
                    FillingDictionary(Data);
                    WriteToLog(Data);
                }
            }
            catch
            {
            }
        }

        private void FillingDictionary(string v)
        {
            try
            {
                string propValue;
                string asd;
                if ((v.Contains("Источники информации")) | (v.Contains("Источник информации")))
                {
                   v = returnText(v);
                    var value = Regex.Escape(@v);
                    asd = @"(?<=" + @value + @":)(.*?)(?=<\/OL>)";
                }
                else
                {
                    v = returnText(v);
                    var value = Regex.Escape(@v);
                    asd = @"(?<=" + @value + @":)(.*?)(?=<h3>)";
                }
                Regex selectValue = new Regex(@asd);
                propValue = selectValue.Match(htmlTextElement).ToString();
                propValue = clearText(propValue);               
                propValue = propValue.Replace("\r\n", Environment.NewLine);
                v = clearText(v);
                if (SE.ContainsKey(v))
                { }
                else
                {
                    SE.Add(v, @propValue);
                    ItemChecked.Add(v, false);
                }
            }
            catch { }
        }

        private string clearText(string Properties)
        {
            Properties = Properties.Replace("&deg;", "°");
            Properties = Properties.Replace("&Delta;", " Δ");
            Properties = Properties.Replace("&middot;", "·");
            Properties = Properties.Replace("<BR>", Environment.NewLine);
            Properties = Properties.Replace("<br>", Environment.NewLine);
            Properties = Properties.Replace("</br>", Environment.NewLine);
            Properties = Properties.Replace("<LI>", Environment.NewLine);
            Properties = Properties.Replace("<P>", Environment.NewLine);
            Properties = Properties.Replace("</h3>", "");
            Properties = Regex.Replace(Properties, "<[^>]*?>", "", RegexOptions.IgnoreCase);
            return Properties;
        }

        private string returnText(string text)
        {
            string returnText = text;
            returnText = returnText.Replace("·", "&middot;");
            returnText = returnText.Replace(" Δ", "&Delta;");
            returnText = returnText.Replace("°", "&deg;");
            return returnText;
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                Sock.Close();
                Receive.Abort();
            }
            catch 
            { 
            }
        }

        private void listElements_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                SendDataToServer(searchElements[listElements.SelectedItem.ToString()]);
                SelectPreperities = "";
                WriteToProperties(SelectPreperities);
            }
            catch { }
                
        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            try
            {
                Sock.Close();
                Client.Close();
            }
            catch { }
        }

        private void listProperties_ItemCheck(object sender, ItemCheckEventArgs e)
        {
            try
            {
                vseVibraniiSvoistva = "";
                if (!ItemChecked[listProperties.SelectedItem.ToString()])
                {
                    ItemChecked[listProperties.SelectedItem.ToString()] = true;

                }
                else
                {
                    ItemChecked[listProperties.SelectedItem.ToString()] = false;
                }

                foreach (KeyValuePair<string, bool> kvp in ItemChecked)
                {
                    if (kvp.Value == true)
                    {
                        vseVibraniiSvoistva = vseVibraniiSvoistva + Environment.NewLine + " - " + kvp.Key + ":" + Environment.NewLine + SE[kvp.Key];
                    }
                }
                vseVibraniiSvoistva = vseVibraniiSvoistva.Replace("\r\n\r\n", "\r\n");
                string hh = vseVibraniiSvoistva.Substring(0, 2);
                if (hh == "\r\n")
                {
                    vseVibraniiSvoistva = vseVibraniiSvoistva.Remove(0, 2);
                }
                WriteToProperties(vseVibraniiSvoistva);
            }
            catch { }
        }

        private void printToolStripMenuItem_Click(object sender, EventArgs e)
        {

            try
            {
                printFont = new Font("Times New Roman", 14);
                PrintDocument pd = new PrintDocument();
                pd.PrintPage += new PrintPageEventHandler
                   (this.pd_PrintPage);
                pd.Print();
            }
            catch { }
        }

        private void pd_PrintPage(object sender, PrintPageEventArgs ev)
        {
            float yPos = 0;
            int count = 0;
            float leftMargin = ev.MarginBounds.Left;
            float topMargin = ev.MarginBounds.Top;
            yPos = topMargin + (count * printFont.GetHeight(ev.Graphics));
            ev.Graphics.DrawString(vseVibraniiSvoistva, printFont, Brushes.Black, leftMargin, yPos, new StringFormat());           
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                saveFileDialog1.FileName = listElements.SelectedItem.ToString();
                saveFileDialog1.Filter = "Текстовые файлы (*.txt)|*.txt|All files (*.*)|*.*|Doc (*.doc)|*.doc";
                if (saveFileDialog1.ShowDialog() == DialogResult.OK)
                {
                    StreamWriter qwe = new StreamWriter(saveFileDialog1.FileName);
                    qwe.Write(vseVibraniiSvoistva);
                    qwe.Close();

                }
            }
            catch { }
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox2 AboutProgramm = new AboutBox2();
            AboutProgramm.ShowDialog();
        }

    }

}

