﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Net.Sockets;
using System.Threading;
using System.Net;
using System.Xml;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;
using System.Diagnostics;

namespace ServerDiplom
{
    public partial class Form1 : Form
    {
        private int LocalPort;
        private Thread ServThread;
        private Thread Client;
        TcpListener Listener;
        bool StatusServer;
        private string pathToBD;

        public Form1()
        {
            InitializeComponent();           
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (pathToBD == null)
            {
                pathToBD = Application.StartupPath.ToString() + "\\database\\";
            }
            StatusServer = true;
            if (textBox1.TextLength < textBox1.MaxLength)
            { MessageBox.Show("Порт подключения введен некорректно!","Ошибка", MessageBoxButtons.OK, MessageBoxIcon.Error); }
            else
            {
                int port = Convert.ToInt32(textBox1.Text);
                textBox2.Text = (textBox2.Text + Environment.NewLine + "Создание сервера...");
                Create(port);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            IP();
        }

        private void IP()
        {
            string myHost = System.Net.Dns.GetHostName();
            string myIP = System.Net.Dns.GetHostByName(myHost).AddressList[0].ToString();
            textBox3.Text = myIP;
        }

        delegate void WriteToLogDelegate(string message);
        public void WriteToLog(string message)
        {
            if (textBox2.InvokeRequired)
            {
                var writeToLog = new WriteToLogDelegate(WriteToLog);
                textBox2.Invoke(writeToLog, message);
            }
            else
            {
                textBox2.Text = textBox2.Text + Environment.NewLine + DateTime.Now + "> " + message;
            }
        }
       
        public void Create(int port)
        {
            LocalPort = port;
            ServThread = new Thread(new ThreadStart(ServStart));
            ServThread.Start();
        }

        private void ServStart()
        {
            Socket ClientSock;
            Listener = new TcpListener(LocalPort);
            Listener.Start();
            WriteToLog("Сервер включен");
            var Clients = new List<Socket>();
            while (true)
            {
                try
                {
                    ClientSock = Listener.AcceptSocket();
                    Clients.Add(ClientSock);
                }
                catch
                {
                    ServThread.Abort();
                    return;
                }
                if (ClientSock.Connected)
                {
                    Client = new Thread(new ParameterizedThreadStart(newClient));
                    Client.Start(ClientSock);
                }
            }
        }

        public void newClient(object Sock)
        {
            Dictionary<string, string> searchElements;
            string data;
            byte[] cldata = new byte[256];
            byte[] SendData = new byte[204800];
            var ClientSock = (Socket)Sock;
            int i = 0;
                WriteToLog("Cоединение установленно.");
                while (true)
                {
                    if (StatusServer == false)
                    { 
                        ClientSock.Close();
                        Listener.Stop();
                        Client.Abort();
                        ServThread.Abort();
                        WriteToLog("Сервер выключен.");
                    }
                    try
                    {
                        i = ClientSock.Receive(cldata);  
                    }
                    catch
                    {
                        ClientSock.Close();
                        return;
                    }
                    try
                    {
                        if (i > 0)
                        {                            
                            data = Encoding.UTF8.GetString(cldata);
                            WriteToLog(data);
                            data = data.Replace("\0", "");
                            if (data.Contains(".htm"))
                            {
                                string Element = LoadElement(data);
                                SendData = Encoding.UTF8.GetBytes(Element);
                                ClientSock.Send(SendData);
                            }
                            else
                            {
                                XmlLoad(data, out searchElements);
                                BinaryFormatter bSerializer = new BinaryFormatter();
                                MemoryStream listSerialStream = new MemoryStream();
                                bSerializer.Serialize(listSerialStream, searchElements);
                                ClientSock.Send(listSerialStream.ToArray());                               
                            }
                            for (int k = i; k > 0; k--)
                            {
                                if (cldata[k] != 0)
                                {
                                    cldata[k] = 0;
                                }
                            }
                        }
                    }
                    catch(Exception ex)
                    {
                        WriteToLog("Искомый файл не найден." + Environment.NewLine + "Причины:" +
                            Environment.NewLine + "1) Расположение базы данных указано неверно." +
                                            Environment.NewLine + "2) Данного вещества нет в базе.");
                    }
                }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            ServerAbort();
        }

        private void ServerAbort()
        {
            try
            {
                StatusServer = false;
                ServThread.Abort();
                Listener.Stop();                                
                WriteToLog("Сервер выключен.");
            }
            catch { }
        }

        private string LoadElement(string nameElement)
        {
            System.Net.WebResponse Result = null;
            string url = pathToBD + nameElement;
            System.Net.WebRequest req = System.Net.WebRequest.Create(url);
            Result = req.GetResponse();
            System.IO.Stream RStream = Result.GetResponseStream();
            System.IO.StreamReader sr = new System.IO.StreamReader(RStream, Encoding.GetEncoding("Windows-1251"));
            new System.IO.StreamReader(RStream, Encoding.GetEncoding("Windows-1251"));
            string Page_Source_Code = sr.ReadToEnd();
            return Page_Source_Code;
        }
        

        private void XmlLoad(string searchWords, out Dictionary<string, string> searchElements)
        {
            XmlDocument reader = new XmlDocument();
            reader.Load(pathToBD+"ContentElement.xml");
            searchElements = new Dictionary<string, string>();
            foreach (XmlNode Element in reader.SelectNodes("Elements/Element"))
            {
                string nameElement = Element.SelectSingleNode("Name").InnerText;
                string hrefToElement = Element.SelectSingleNode("Href").InnerText;
                if (nameElement.IndexOf(searchWords, StringComparison.OrdinalIgnoreCase)>=0)              
                {
                    if (searchElements.ContainsKey(nameElement))
                    { }
                    else
                    {
                        searchElements.Add(nameElement, hrefToElement);
                    }
                }               
            }
        }
          

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                string History = textBox2.Text;
                File.WriteAllText(pathToBD + "History.txt", History);
            }
            catch { }
            ServerAbort();
        }

        private void settingsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form2 Settings = new Form2();
            Settings.ShowDialog();
            pathToBD = Settings.getPath+"\\";
        }

        private void saveHistoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                string History = textBox2.Text;
                File.WriteAllText(pathToBD + "History.txt", History);
            }
            catch { }
        }

        private void openHistoryToolStripMenuItem_Click(object sender, EventArgs e)
        {
            try
            {
                Process.Start(pathToBD + "History.txt");
            }
            catch
            {
                MessageBox.Show("Файл с историей работы  сервера не был ранее создан.", "Ошибка", MessageBoxButtons.OK ,MessageBoxIcon.Warning);
            }
        }

        private void aboutProgramToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AboutBox1 aboutProgramm = new AboutBox1();
            aboutProgramm.ShowDialog();
        }
    }

}

